from typing import List
from re import compile, Pattern
from hashlib import md5


class MD5(object):
    NAME: str = "MD5"
    EXT: List[str] = [".md5"]
    SYNTAX: List[Pattern] = [compile(r"^;*$"), compile(r"^.* [0-9a-fA-F]{32}$")]
    REGEX: Pattern = compile(r"[0-9a-fA-F]{32}")
    NULL: str = "D41D8CD98F00B204E9800998ECF8427E"

    def __init__(self):
        self.cksum = md5(usedforsecurity=False)

    def gensum(self, data: bytes):
        self.cksum.update(data)

    def reset(self):
        self.__init__()

    def format(self, fpath) -> str:
        return " ".join([self.__repr__(), fpath])

    def __repr__(self) -> str:
        return self.cksum.hexdigest().upper()
